package org.jeecg.modules.stm.page.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;


import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.page.entity.PageMetricconfig;
import org.jeecg.modules.stm.page.service.IPageMetricconfigService;
import org.jeecg.modules.stm.page.vo.PageMetricMoniVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Map;
import java.util.List;

/**
 * @Description: 风险监测指标配置
 * @Author: jeecg-boot
 * @Date:   2024-01-10
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/page/pageMetricconfig")
@Slf4j
public class PageMetricconfigController extends JeecgController<PageMetricconfig, IPageMetricconfigService> {
	@Autowired
	private IPageMetricconfigService pageMetricconfigService;
	
	/**
	 * 分页列表查询
	 *
	 * @param pageMetricconfig
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "风险监测指标配置-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<PageMetricconfig>> queryPageList(PageMetricconfig pageMetricconfig,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<PageMetricconfig> queryWrapper = QueryGenerator.initQueryWrapper(pageMetricconfig, req.getParameterMap());
		Page<PageMetricconfig> page = new Page<PageMetricconfig>(pageNo, pageSize);
		IPage<PageMetricconfig> pageList = pageMetricconfigService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	 @GetMapping(value = "/queryPageMetricconfig")
	 public Result<List<PageMetricMoniVo>> queryPageMetricconfig() {
		 List<PageMetricMoniVo> pageList = pageMetricconfigService.queryPageMetricconfig();
		 return Result.OK(pageList);
	 }
	/**
	 *   添加
	 *
	 * @param pageMetricconfig
	 * @return
	 */
	@AutoLog(value = "风险监测指标配置-添加")
	  
	//@RequiresPermissions("page:page_metricconfig:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody PageMetricconfig pageMetricconfig) {
		pageMetricconfigService.save(pageMetricconfig);
		return Result.OK("添加成功！");
	}

	@PostMapping(value = "/addBatch")
	public Result<String> addBatch(@RequestBody Map<String,String> paramMap) {
		String ids = paramMap.get("ids").toString();
		String sta = paramMap.get("pageStatus").toString();
		if(ids!=null){
			String[] idAry = ids.split(",");
			List<PageMetricconfig> listMetric = new ArrayList<>();
			if(sta.equals("1")) {
				for(String id:idAry ){
					PageMetricconfig pfg = new PageMetricconfig();
					pfg.setId(Integer.valueOf(id));
					pfg.setPageStatus(1);
					listMetric.add(pfg);
				}
				pageMetricconfigService.removeBatchByIds(Arrays.asList(idAry));
				pageMetricconfigService.saveBatch(listMetric);
			} else {
				pageMetricconfigService.removeBatchByIds(Arrays.asList(idAry));
			}

		}
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param pageMetricconfig
	 * @return
	 */
	@AutoLog(value = "风险监测指标配置-编辑")
	  
//	@RequiresPermissions("page:page_metricconfig:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody PageMetricconfig pageMetricconfig) {
		Integer id = pageMetricconfig.getId();
		if(pageMetricconfig.getPageStatus()==1){
			pageMetricconfig.setPageStatus(1);
			pageMetricconfigService.save(pageMetricconfig);
		} else {
			pageMetricconfigService.removeById(id);
		}

		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "风险监测指标配置-通过id删除")
	  
	//@RequiresPermissions("page:page_metricconfig:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		pageMetricconfigService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "风险监测指标配置-批量删除")
	  
	@RequiresPermissions("page:page_metricconfig:deleteBatch")
	//@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.pageMetricconfigService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "风险监测指标配置-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<PageMetricconfig> queryById(@RequestParam(name="id",required=true) String id) {
		PageMetricconfig pageMetricconfig = pageMetricconfigService.getById(id);
		if(pageMetricconfig==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(pageMetricconfig);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param pageMetricconfig
    */
    @RequiresPermissions("page:page_metricconfig:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, PageMetricconfig pageMetricconfig) {
        return super.exportXls(request, pageMetricconfig, PageMetricconfig.class, "风险监测指标配置");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
   // @RequiresPermissions("page:page_metricconfig:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, PageMetricconfig.class);
    }

}
